

const { ccclass, property } = cc._decorator;

@ccclass
export default class Test extends cc.Component {

    @property({
        type: cc.Node,
    })
    private color1: cc.Node = null;

    @property({
        type: cc.Node,
    })
    private color2: cc.Node = null;

    @property({
        type: cc.Node,
    })
    private color3: cc.Node = null;

    @property({
        type: cc.Node
    })
    private color4: cc.Node = null;

    private isTest: boolean = true;

    onLoad() {

        // 与color1的相互矛盾
        this.color4.opacity = 100;
        this.color4.color = cc.color(255, 255, 255);
    }

    onTest() {
        if (this.isTest) {

            // 如果按照以前的逻辑，则下面的代码应该效果一致，但是在2.1.2 color1的透明度没有生效，似乎是被颜色的255覆盖了

            // 如果说这是2.2的新逻辑，那么color4的透明度也应该是255

            this.color1.opacity = 100;
            this.color1.color = cc.color(255, 255, 255);


            this.color2.color = cc.color(255, 255, 255);
            this.color2.opacity = 100;

            this.color3.color = cc.color(255, 255, 255, 100);

        } else {
            this.color1.opacity = 255;
            this.color1.color = cc.color(255, 0, 0);


            this.color2.color = cc.color(255, 0, 0);
            this.color2.opacity = 255;

            this.color3.color = cc.color(255, 0, 0, 255);
        }

        this.isTest = !this.isTest;
    }
}
